#include "io.h"

#define MYFS_SBI(sb)     ((struct myfs_sb_info *)(sb->s_fs_info))
#define MYFS_DISK_SB(sb)  (MYFS_SBI(sb)->ms) 
#define MYFS_MAGIC_STR	"MyFs V 1.1" /*its a string value*/
#define MYFS_SUPER_MAGIC 0xdeadbeef /*its a hex value*/
#define MYFS_DEFAULT_BS	4096
#define MYFS_SUPER_BLOCK  0
#define MYFS_INODE_BLOCK 1 /*inode info stored after super block*/
#define MYFS_ROOT_BLOCK 2 /*inode info stored after super block*/
			   /*No of inode that can be stored = blocksize/sizeof(myfs_inode)*/	
#define MAGIC_LEN 10
#define MYFS_ROOT_INO 2
#define MYFS_MAX_BLOCKS 10
#define BLOCK_BMP 4
#define INODE_BMP BLOCK_BMP 
#define MAX_NAME_LEN 25

typedef unsigned int unsigned32;
typedef unsigned char uchar;
typedef unsigned short unsigned16;
 

struct myfs_super_block {

/*its the disk super block it has to contain the inode bitmap
and block bitmap 
and a few basic information like blick size and number of blocks in filesystem 
*/
	unsigned32 root;
	unsigned32 inode_bmp;
	unsigned32 block_bmp; 
	unsigned32 block_size;
	unsigned32 blocks;
	unsigned32 s_magic;
	uchar magic[MAGIC_LEN];
};

struct myfs_sb_info {
/*memory structure related to superblock */
	struct myfs_super_block *ms;
};

struct myfs_filesys {
	
	char* dev_name;	
	int fs_dev;/*descriptor for opened filesystem device*/
	struct buffer_head *bh; /*buffer to hold superblock*/
	struct myfs_super_block *myfs_ondisk_sb;	
	int fs_dirt;
	unsigned int blocksize;
};

struct myfs_inode {
	unsigned16 ino;
	unsigned16 uid;
	unsigned16 gid;
	unsigned16 mode;
	unsigned16 perm;
	unsigned16 size;
	unsigned16 block_no;
	unsigned16 links;
};


struct myfs_dir_entry {
	int ino;
	char name[MAX_NAME_LEN];
	int len;
};


